<?php
class SiteManager
{
	public $lang="en";
	public $arrPages = array();
	public $domain = "";
	public $multi_language = false;
	private $db;
	public $running_mode=1;
	public $user = "";
	public $arrUser = array();
	public $user_settings = array();
	public $global_categories=array();
	public $categories_count;
	public $default_page_name="en_Home";
	public $isMainAdminPanel = false;
	public $admin_settings = array();
	public $is_default_page=false;
	public $color_code="";
	public $color_rgb="";
	public $color_code_light="";
	
	function __construct()
	{
		
		
		
		
	
		
	}
	
	/// The website title and meta description and keywords,
	/// which can be used for SEO purposes
	public $Title = true;
	public $Description = true;
	public $Keywords = true;
	
	/// The current language version on the website
	public $Language = true;
	
	/// The html code of the website template
	public $TemplateHTML = "";
	
	/// The site paramets
	public $params = array();
	public $user_params = array();
	
	public $IsExtension = false;
	public $ExtensionFile = false;
	
	public $DefaultPage = "";
	public $DefaultPageId = 0;
	
	public $isAdminPanel = false;
		
	public $MenuHTML = "";
	
	function SetLanguage($lang)
	{
		$this->lang= substr(preg_replace("/[^a-z]/i", "", $lang), 0, 2); 
	}
		
	function SetDatabase(Database $db)
	{
		$this->db = $db;
	
	}
	
	function LoadSettings()
	{
		global $database,$DBprefix,$MULTI_LANGUAGE_SITE,$DOMAIN_NAME,$_REQUEST,$is_mobile;
		
		if(isset($_REQUEST["p"]))
		{
			$this->user=$this->sanitize($_REQUEST["p"]);
			
			$this->arrUser=$database->DataArray("users","username='".($this->user)."'");
			
			if(!isset($this->arrUser)) die("Such user doesn't exist.");
			
			
			$this->user_settings=$database->DataArray("user_settings","username='".($this->user)."'");
		}
		
		$this->admin_settings=$this->db->DataArray("admin_users","id=1");
		
		$this->domain = $DOMAIN_NAME;
		if($database->SQLCount("languages","")>1)
		{
			$MULTI_LANGUAGE_SITE=true;
		}
		$this->multi_language = $MULTI_LANGUAGE_SITE;
		
		if(!isset($_REQUEST["page"]) && !isset($_REQUEST["mod"]))
		{
			$this->is_default_page=true;
		}
		
		if(isset($_REQUEST["lang"])&&$_REQUEST["lang"]!="")
		{
			$lng=$_REQUEST["lang"];
			$this->ms_w($lng);
			$lng=substr(preg_replace("/[^a-z]/i", "", $_REQUEST["lang"]), 0, 2);
			
			if(file_exists("include/texts_".$lng.".php"))
			{
				$this->lang= $lng; 
			}
			else
			{
				echo "<i>Please create a language file for this new language!</i>";
			}
		}
		else
		if(isset($_REQUEST["page"])&&strpos($_REQUEST["page"],"_")!==false)
		{
			list($lang,$link)=explode("_",urldecode($_REQUEST["page"]),2);
		
			if(trim($lang)!="" && strlen($lang)==2)
			{
				$this->lang= substr(preg_replace("/[^a-z]/i", "", $lang), 0, 2); 
		
			}
		}
		else
		{
			if($MULTI_LANGUAGE_SITE)
			{
				$default_language = $database->DataArray("languages","default_language=1");
				
				if(isset($default_language["code"])&&strlen($default_language["code"])==2)
				{
					$this->lang = strtolower($default_language["code"]);
				}
			}
			
		}
		
		
		if
		(
			isset($_REQUEST["mod"]) &&
			$_REQUEST["mod"] != "" &&
			file_exists("extensions/".$_REQUEST["mod"].".php")
		)
		{
			$this->IsExtension = true;
			$this->ExtensionFile = $_REQUEST["mod"];
		}
		
		$sql_query = "select id,value from ".$DBprefix."settings";
		
		$results = $this->db->Query($sql_query);
	
		while($row = $database->fetch_array($results))
		{
			$this->params[$row["id"]]=$row["value"];
		}
		
		$this->DefaultPageId = $this->params[1];
	
		date_default_timezone_set("Europe/London");
	
	
		if(isset($_REQUEST["p"])&&trim($_REQUEST["p"])!="")
		{
			$this->ms_w($_REQUEST["p"]);
			
			$this->arrUser=$this->db->DataArray("users","username='".$_REQUEST["p"]."'");
		}
	}
	
	
	function SetPage()
	{
	
	}
	
	function LoadTemplate($template_id)
	{

		if($this->user!="")
		{
				
		
			$templateArray=array();
			
			if(file_exists("user_templates/".$this->arrUser["template"]."/template.htm"))
			{
				$templateArray["html"] = file_get_contents("user_templates/".$this->arrUser["template"]."/template.htm");
			}
			else
			{
				$templateArray["html"] = file_get_contents("user_templates/1/template.htm");
			}
			
			
			if($this->user_settings["custom_color"]!="")
			{
				
				
				$custom_color=$this->user_settings["custom_color"];
				$this->color_code=$custom_color;
				
				list($r, $g, $b) = sscanf($custom_color, "%02x%02x%02x");
				$this->color_rgb=$r.",".$g.",".$b;
				
				$custom_color_light=
				dechex(hexdec($custom_color) + hexdec(202020));
				
				$this->color_code_light=$custom_color_light;
				
				$templateArray["html"]=str_replace("[CUSTOM_COLOR]","#".$custom_color,$templateArray["html"]);	
				
				$templateArray["html"] = str_replace
				(
					"</head>",
		"	<style>
		.custom-back-color,.btn-primary
		{
			background:#".$custom_color." !important;
			background-color:#".$custom_color." !important;
			border-color:#".$custom_color." !important;
		}
		.btn-primary{color:#ffffff !important}
		
		.custom-back-color-light
		{
			background:#".$custom_color_light." !important;
			background-color:#".$custom_color_light." !important;
		}
		.custom-color,h1,h2,h3
		{
			color:#".$custom_color." !important;
		}
		.custom-color-light
		{
			color:#".$custom_color_light." !important;
		}
		</style>
		</head>",
						$templateArray["html"]
					);
		}
		else
		{
			$templateArray["html"]=str_replace("[CUSTOM_COLOR]","",$templateArray["html"]);	
		}
				
				
				if($this->user_settings["layout_mode"]=="boxed")
				{
					$templateArray["html"] = 
					str_replace("navbar-fixed-top","",$templateArray["html"]);
					$templateArray["html"] = 
					str_replace("<body>","<body><div class=\"container\">",$templateArray["html"]);
					$templateArray["html"] = 
					str_replace("</body>","</div></body>",$templateArray["html"]);
				}
				
				if($this->user_settings["background"]!="")
				{
					$templateArray["html"] = str_replace
					(
						"</head>",
		"	<style>
		body
		{
			background-image:url('".$this->get_file_prefix()."images/backgrounds/".$this->user_settings["background"].".png')
			
		}
		</style>
		</head>",
						$templateArray["html"]
					);
				}
			
			
				if($this->arrUser["adv"]==1)
			{
		
				if(trim($this->params[1501])!="")
				{
					$templateArray["html"] = 
					str_replace("<body>","<body><div class=\"width-100 text-center\">".$this->params[1501]."</div><br/>",$templateArray["html"]);
				}
				
				
				
				if(trim($this->params[1502])!="")
				{
					$templateArray["html"] = 
					str_replace("<body>","<body><div class=\"relative-200 pull-right text-right\">".$this->params[1502]."</div>",$templateArray["html"]);
				}
			

				if(trim($this->params[1503])!="")
				{
					$templateArray["html"] = 
					str_replace("</body>","<br/><div class=\"width-100 text-center\">".$this->params[1503]."</div></body>",$templateArray["html"]);
				}	
				
			

				if(trim($this->params[1504])!="")
				{
					$templateArray["html"] = 
					str_replace("<body>","<body><div class=\"relative-200 pull-left text-left\">".$this->params[1504]."</div>",$templateArray["html"]);
				}

								
			
			}
			
			if(isset($this->arrUser["adv_1"])&&trim($this->arrUser["adv_1"])!="")
			{
				$templateArray["html"] = 
				str_replace("<body>","<body><div class=\"width-100 text-center\">".$this->arrUser["adv_1"]."</div><br/>",$templateArray["html"]);
			}

				
			if(isset($this->arrUser["adv_2"])&&trim($this->arrUser["adv_2"])!="")
			{
				$templateArray["html"] = 
				str_replace("<body>","<body><div class=\"relative-200 pull-right text-right\">".$this->arrUser["adv_2"]."</div>",$templateArray["html"]);
			}

			if(isset($this->arrUser["adv_3"])&&trim($this->arrUser["adv_3"])!="")
			{
				$templateArray["html"] = 
				str_replace("</body>","<br/><div class=\"width-100 text-center\">".$this->arrUser["adv_3"]."</div></body>",$templateArray["html"]);
			}	
				
			if(isset($this->arrUser["adv_4"])&&trim($this->arrUser["adv_4"])!="")
			{
				$templateArray["html"] = 
				str_replace("<body>","<body><div class=\"relative-200 pull-left text-left\">".$this->arrUser["adv_4"]."</div>",$templateArray["html"]);
			}	
				

			if($this->GetParam("SEO_URLS")==1)
			{
				$templateArray["html"] = 
				str_replace('href="user_templates/','href="http'.$this->check_https().'://'.$this->domain.'/user_templates/',$templateArray["html"]);
				
				$templateArray["html"] = 
				str_replace('src="user_templates/','src="http'.$this->check_https().'://'.$this->domain.'/user_templates/',$templateArray["html"]);
				
				
				$templateArray["html"] = 
				str_replace('href="css/','href="http'.$this->check_https().'://'.$this->domain.'/css/',$templateArray["html"]);
				
				$templateArray["html"] = 
				str_replace('src="images/','src="http'.$this->check_https().'://'.$this->domain.'/images/',$templateArray["html"]);
				
				$templateArray["html"] = 
				str_replace('href="index.php','href="http'.$this->check_https().'://'.$this->domain.'/index.php',$templateArray["html"]);
				
				$templateArray["html"] = 
				str_replace('href="USERS/','href="http'.$this->check_https().'://'.$this->domain.'/USERS/',$templateArray["html"]);
				
				$templateArray["html"] = 
				str_replace('href="js/','href="http'.$this->check_https().'://'.$this->domain.'/js/',$templateArray["html"]);
				
				$templateArray["html"] = 
				str_replace('src="include/','src="http'.$this->check_https().'://'.$this->domain.'/include/',$templateArray["html"]);
				
			}
			
			$templateArray["html"]=
			str_replace("[LINK_HOME]",$this->user_site_link($this->user),$templateArray["html"]);
			
			$templateArray["html"]=
			str_replace("[BLOG_TITLE]",stripslashes($this->arrUser["blog_title"]),$templateArray["html"]);
			
			$templateArray["html"]=
			str_replace("[BLOG_DESCRIPTION]",stripslashes($this->arrUser["description"]),$templateArray["html"]);
			
			$blog_author_image="images/user.png";
	
			if(trim($this->arrUser["user_logo"])!="")
			{
				if(file_exists("thumbnails/".$this->arrUser["user_logo"].".jpg"))
				{
					$blog_author_image="thumbnails/".$this->arrUser["user_logo"].".jpg";
				}
			}
			
			$templateArray["html"]=
			str_replace("[AUTHOR_IMAGE]",$blog_author_image,$templateArray["html"]);
			
		}
		else
		if(file_exists($template_id.".htm"))
		{
			$templateArray=array();
			$templateArray["html"] = file_get_contents($template_id.".htm");
		}		
		else
		if($template_id != 0 && $template_id != -1)
		{
			$templateArray = $this->db->DataArray("templates","id=".$template_id);
		}
		else
		{
			
			if($template_id==-1&&file_exists("../template-admin.htm"))
			{
				$templateArray=array();
				$templateArray["html"] = file_get_contents('../template-admin.htm');
				
				
				
				$templateArray["html"] = str_replace('href="css/','href="../css/',$templateArray["html"]);
				$templateArray["html"] = str_replace('src="js/','src="../js/',$templateArray["html"]);
				
				if(file_exists("content-template.htm"))
				{
					$content_template= file_get_contents('content-template.htm');
					$templateArray["html"] = str_replace('<site content/>',$content_template,$templateArray["html"]);
				}
				
				
			}
			else
			if($template_id==-1&&file_exists("../template.htm"))
			{
				$templateArray=array();
				$templateArray["html"] = file_get_contents('../template.htm');
				
				
				
				$templateArray["html"] = str_replace('href="css/','href="../css/',$templateArray["html"]);
				$templateArray["html"] = str_replace('src="js/','src="../js/',$templateArray["html"]);
				
				if(file_exists("content-template.htm"))
				{
					$content_template= file_get_contents('content-template.htm');
					$templateArray["html"] = str_replace('<site content/>',$content_template,$templateArray["html"]);
				}
				
				
			}
			else
			if(file_exists("template.htm"))
			{
				$templateArray=array();
				$templateArray["html"] = file_get_contents('template.htm');
			}
			else
			{
				$templateArray= $this->db->DataArray("templates","id=".$this->params[10]);
			}
		}
		
		$this->TemplateHTML = stripslashes($templateArray["html"]);
		$this->TemplateHTML = str_replace(" />","/>",$this->TemplateHTML);
		
		
		//custom colors 
		
		if($this->user=="" && !$this->isMainAdminPanel && $this->admin_settings["custom_color"]!="")
		{
	
			$custom_color=$this->admin_settings["custom_color"];
			$this->color_code=$custom_color;
			
			
			list($r, $g, $b) = sscanf($custom_color, "%02x%02x%02x");
			$this->color_rgb=$r.",".$g.",".$b;
			
			$custom_color_light=
			dechex(hexdec($custom_color) + hexdec(202020));
			
			$this->color_code_light=$custom_color_light;
			
			
			$this->custom_color_light=$custom_color_light;
			$this->TemplateHTML = str_replace
			(
				"</head>",
				"<style>
			.custom-back-color,.btn-primary
			{
				background:#".$custom_color." !important;
				background-color:#".$custom_color." !important;
				border-color:#".$custom_color." !important;
			}
			.btn-primary{color:#ffffff !important}
			.custom-border-color
			{
				border-color:#".$custom_color." !important;
			}
			
			
			.custom-back-color a
			{
				color:#ffffff !important;
			}
			
			.custom-back-color-light
			{
				background:#".$custom_color_light." !important;
				background-color:#".$custom_color_light." !important;
			}
			.custom-color,h1,h2,.post-details-link,.results-post-title,.main_category_link
			{
				color:#".$custom_color." !important;
			}
			.post-details-info
			{
				border-color:#".$custom_color." !important;
			}
			.custom-color-light
			{
				color:#".$custom_color_light." !important;
			}
			
			.custom-gradient
			{
				background-color:#".$custom_color." !important;
				background-image:-webkit-gradient(linear, 0% 0%, 0% 100%, from(#".$custom_color."), to(#".$custom_color_light.")) !important;
				background-image:-webkit-linear-gradient(top, #".$custom_color.", #".$custom_color_light.") !important;
				background-image:-moz-linear-gradient(top, #".$custom_color.", #".$custom_color_light.") !important;
				background-image:-ms-linear-gradient(top, #".$custom_color.", #".$custom_color_light.") !important;
				background-image:-o-linear-gradient(top, #".$custom_color.", #".$custom_color_light.") !important;
				filter:progid:DXImageTransform.Microsoft.gradient(GradientType=0, startColorstr=#".$custom_color.", endColorstr=#".$custom_color_light.") !important;
				-ms-filter:\"progid:DXImageTransform.Microsoft.gradient (GradientType=0, startColorstr=#".$custom_color.", endColorstr=#".$custom_color_light.")\" !important;
			}
			
			 input[type=\"submit\"].custom-gradient
			 {
			  color:#ffffff !important;
			}
			
			.custom-gradient-2
			{
				background-color:#ebebeb !important;
				background-image:-webkit-gradient(linear, 0% 0%, 0% 100%, from(#fbfbfb), to(#ebebeb)) !important;
				background-image:-webkit-linear-gradient(top, #fbfbfb, #ebebeb) !important;
				background-image:-moz-linear-gradient(top, #fbfbfb, #ebebeb) !important;
				background-image:-ms-linear-gradient(top, #fbfbfb, #ebebeb) !important;
				background-image:-o-linear-gradient(top, #fbfbfb, #ebebeb) !important;
				filter:progid:DXImageTransform.Microsoft.gradient(GradientType=0, startColorstr=#fbfbfb, endColorstr=#ebebeb) !important;
				-ms-filter:\"progid:DXImageTransform.Microsoft.gradient (GradientType=0, startColorstr=#fbfbfb, endColorstr=#ebebeb)\" !important;
				color:#000000 !important;
				background-color: #ffffff !important;
				border-color: #cccccc !important;
			}
			
			</style>
			</head>",
							$this->TemplateHTML
						);
					}
					
					
			if($this->admin_settings["background"]!=""&& $this->user=="")
			{
						$this->TemplateHTML = str_replace
						(
							"</head>",
			"	<style>
			body
			{
				background-image:url('images/backgrounds/".$this->admin_settings["background"].".png') !important
			}
			</style>
			</head>",
							$this->TemplateHTML
						);
		}
		
		//end custom colors
		
		
		
		
		
		
		
		$pattern = "/{(\w+)}/i";
		preg_match_all($pattern, $this->TemplateHTML, $items_found);
		foreach($items_found[1] as $item_found)
		{
			global $$item_found;
			if(isset($$item_found))
			{
				$this->TemplateHTML=str_replace("{".$item_found."}",$$item_found,$this->TemplateHTML);
			}
		}
		
		if(isset($_REQUEST["mod"]))
		{
			$this->TemplateHTML=str_replace('<site browse_locations/>','<br/><br/>',$this->TemplateHTML);
		}
	}
	
	function Render()
	{
		if($this->isAdminPanel==false && $this->params[60] == "NO")
		{
			$this->TemplateHTML=str_replace
			(
				"</head>",
				"<style>
				td, div, span{font-family:".$this->params[61].";font-size:".$this->params[62]."px;color:".$this->params[63]."}
				a:link{color:".$this->params[64]."}
				a:visited{color:".$this->params[65]."}
				a:hover{color:".$this->params[66]."}
				h1,h2,h3,h4,h5,h6{color:".$this->params[67]."}
				</style></head>",
				$this->TemplateHTML
			);
		}
		echo $this->TemplateHTML;
	}
	
	function LanguagesMenu($page_id)
	{
		global $lang,$database,$website;
		$strResult="";

		$tableLanguages=$database->DataTable("languages","WHERE active=1");
		
		$bFirst=true;
	
				
		while($arrLanguages=$database->fetch_array($tableLanguages))
		{
			$strResult.="
					
			<li class=\"nav-item main-menu-item\"> <a href=\"index.php?lang=".strtolower($arrLanguages["code"]).($page_id!=""?"&page_id=".$page_id:"")."\"><img alt=\"".stripslashes($arrLanguages["name"])."\"  title=\"".stripslashes($arrLanguages["name"])."\" src=\"images/flags/".strtoupper($arrLanguages["code"]).".gif\" style=\"margin-left:6px\"/></a> </li>
					
			";	
		}
		
		return $strResult;
	}
	
	function GetSubArray($parent,$arr)
	{
		$result = array();

		for($i=0;$i<sizeof($arr);$i++)
		{
			if($arr[$i][1] == $parent)
			{
				array_push($result, $arr[$i]);
			}
		}

		return $result;

	}


	function GenerateMenu()
	{
		global $page,$database;
		$strResult="";
		
		$site_pages=$database->DataTable("pages","WHERE id>0 AND active_".$this->lang."=1 order by id");
		
		while ($row = $database->fetch_array($site_pages))
		{
			array_push($this->arrPages, array($row['id'], $row['parent_id'], $row["link_".$this->lang], $row["custom_link_".$this->lang], $row["only_bottom"], (isset($row["url_".$this->lang])?$row["url_".$this->lang]:"")));
		}
				
		$strLinkTemplate = '<li class="nav-item"><a class="nav-link" href="[LINK_HREF]">[LINK_TEXT]</a> </li>';
			
		foreach($this->arrPages as $arrPage)
		{
			
			if($arrPage[1]!=0) continue;
			if(trim($arrPage[3])=="1")  continue;
			
			$arrSubPages = $this->GetSubArray($arrPage[0],$this->arrPages);
		
			if($this->DefaultPage=="" && isset($_REQUEST["p"])&&trim($_REQUEST["p"])!="")
			{
				$this->DefaultPage = $this->lang."_".stripslashes($arrPage[2]);
			}
			else
			if($this->DefaultPageId == $arrPage[0]) 
			{
				$this->DefaultPage = $this->lang."_".stripslashes($arrPage[2]);
				
				if(isset($_REQUEST["page"])&&$_REQUEST["page"]==$this->DefaultPage)
				{
					$this->is_default_page=true;
				}
			}
			
			$strResult .= "\n";
			$strSubResult = "";
			
			if(sizeof($arrSubPages) > 0)
			{
				$strSubResult .= "\n <div class=\"dropdown-menu\">\n";
				foreach($arrSubPages as $arrSubPage)
				{
					$strSubResult .= "<a class=\"dropdown-item\" href=\"".$this->GenerateLink($this->params[1111],$this->params[1112],$this->lang,stripslashes($arrSubPage[2]))."\"><span class=\"custom-color\">".stripslashes($arrSubPage[2])."</span></a>\n";
				}
				
				$strSubResult .= " </div>\n";
				$strResult .= str_replace("[LINK_TEXT]",stripslashes($arrPage[2]).' <span class="caret"></span>',str_replace("[LINK_HREF]",$this->GenerateLink($this->params[1111],$this->params[1112],$this->lang,stripslashes($arrPage[2])),
				str_replace("</li>",$strSubResult."</li>",str_replace("<li class=\"nav-item\">","<li class=\"nav-item dropdown\">",str_replace('<a class="nav-link"','<a class="nav-link dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false"',$strLinkTemplate)))
				));
				
			}
			else
			{
				if($arrPage[4]==1) continue;
				$strResult .= str_replace("[LINK_TEXT]",stripslashes($arrPage[2]),str_replace("[LINK_HREF]",$this->GenerateLink($this->params[1111],$this->params[1112],$this->lang,stripslashes($arrPage[2]),stripslashes($arrPage[5])),$strLinkTemplate));
			}
		}
		$this->MenuHTML = $strResult;
	}

	function GenerateLink($urlFormat,$urlLanguage,$lang,$page,$custom_url="")
	{
		global $DOMAIN_NAME;
		if($this->GetParam("SEO_URLS")==1)
		{
			if($this->user==""&&$lang."_".stripslashes($page) == "en_Home")
			{
				return "http".$this->check_https()."://".$DOMAIN_NAME;
			}
			else
			if($this->user==""&&$custom_url!="")
			{
				return urlencode($custom_url).".html";		
			}
			else
			{
				$path="";
				if($this->user!="")
				{
					if($this->GetParam("STORES_URL_FORMAT")==1)
					{
						$path = "http".$this->check_https()."://".$this->domain."/".$this->user."/";
					}
					else
					{
						$path = "http".$this->check_https()."://".$this->user.".".str_replace("www.","",$this->domain)."/";
					}
				}
				return $path.(urlencode($lang."_".stripslashes($page))).".html";	
			}
		}
		else
		{
			if($this->user==""&&$custom_url!="")
			{
				return "index.php?page=".urlencode($custom_url);	
			}
			else
			{
				return "index.php?page=".urlencode($lang."_".stripslashes($page)).($this->user!=""?"&p=".$this->user:"");	
			}
		}
		
		
		
	}
	

	function ms_w($input)
	{
		if(!preg_match("/^[a-zA-Z0-9_]+$/i", $input)) die("");
	}
	
	function ms_ew($input)
	{
		if(!preg_match("/^[a-zA-Z0-9_\-. @]+$/i", $input)) die("");
	} 
	
	function ms_i($input)
	{
		if(!is_numeric($input)) die("");
	} 
	
	function ms_ia($input)
	{
		foreach($input as $inp) if(!is_numeric($inp)) die("");
	}
	
	function ForceLogin()
	{
		die("<script>document.location.href='login.php';</script>");
	}
	
	function aParameter($param_id)
	{
		return $this->params[$param_id];
	}
	
	function Statistics()
	{
		global $database,$_REQUEST,$_SERVER,$DBprefix;
		
		if(isset($_SERVER["HTTP_X_REAL_IP"]) && $_SERVER["HTTP_X_REAL_IP"]!="")
		{
			$user_ip=$_SERVER["HTTP_X_REAL_IP"];
		}
		else
		{
			$user_ip=$_SERVER["REMOTE_ADDR"];
		}

		if($this->user!="")
		{
			
			$database->Query
			("
				UPDATE ".$DBprefix."users
				SET visits=visits+1
				WHERE username='".$this->user."'
			");
			
			$current_date=date("m/d/Y");
			
			if($database->SQLCount("user_statistics","WHERE date='".$current_date."' AND username='".$this->user."'")==0)
			{
				$database->SQLInsert
				(
					"user_statistics",
					array("date","username","visits"),
					array($current_date,$this->user,1)
				);
			}
			else
			{
				$database->SQLQuery
				(
					"UPDATE ".$DBprefix."user_statistics 
				    SET visits=visits+1 
					WHERE date='".$current_date."' 
					AND username='".$this->user."'"
				);
			}
			
			$referrer=(isset($_SERVER["HTTP_REFERER"])?$_SERVER["HTTP_REFERER"]:"");

			if
			(
				preg_match('/https?:\/\/(www.)?('.str_replace("www.","",$_SERVER["HTTP_HOST"]).'|'.str_ireplace("www.","",$this->domain).')\/?/', $referrer, $match)
			) 
			{
				
			}
			else
			{
				
				$database->SQLInsert
				(
					"user_referrals",
					array("date","username","referer","host","page"),
					array($current_date,$this->user,$referrer,$user_ip,(isset($_SERVER['REQUEST_URI'])?$_SERVER['REQUEST_URI']:""))
				);
			}
		}
		else
		{
			$database->SQLInsert
			(
				"statistics",
				array("date","timestamp","host","referer","page"),
				array(date("F j, Y"),time(),$user_ip,(isset($_SERVER["HTTP_REFERER"])?$_SERVER["HTTP_REFERER"]:""),(isset($_REQUEST["page"])?$_REQUEST["page"]:"home"))
			);
		}
	}

	
	function ProcessTags()
	{
		global $FACEBOOK_APPID,$ENABLE_FACEBOOK_LOGIN,$MULTI_LANGUAGE_SITE,$DBprefix,$DOMAIN_NAME;
		
		$database=$this->db;
		$website=$this;
		
		if(file_exists("include/texts_".$this->lang.".php"))
		{
			include("include/texts_".$this->lang.".php");
		}
		$this->TemplateHTML = str_replace("<site menu/>",$this->MenuHTML,$this->TemplateHTML);
				
		$arrTags = unserialize($this->params[100]);
		
		if(!isset($_REQUEST["mod"])&&(!isset($_REQUEST["page"])||(isset($_REQUEST["page"])&&$_REQUEST["page"]=="en_Home")))
		{
			if($this->user!="")
			{
				$tag_pos = strpos($this->TemplateHTML,"<site news_slider/>");
				
				if($tag_pos !== false)
				{
					array_push($arrTags, array("news_slider","news_slider_tag.php"));
				}
				
			}
			else
			{
				array_push($arrTags, array("home_slider","home_slider_tag.php"));
				
				
			}
		}
		else
		{
			$this->TemplateHTML=str_replace
			(
				'class="navbar"',
				'class="navbar navbar-internal"',
				$this->TemplateHTML
			);
			
			if(file_exists("images/logo-dark.png"))
			{
				$this->TemplateHTML=str_replace
				(
					'logo.png',
					'logo-dark.png',
					$this->TemplateHTML
				);
			}
		}
		
		if($this->user!="")
		{
			$tag_pos = strpos($this->TemplateHTML,"<site album_files/>");
			
			if($tag_pos !== false)
			{
				array_push($arrTags, array("album_files","album_files_tag.php"));
		
			}
			array_push($arrTags, array("social_networks","social_networks_tag.php"));
			
			array_push($arrTags, array("profile_picture","profile_picture_tag.php"));
			array_push($arrTags, array("profile_picture_url","profile_picture_url_tag.php"));
			array_push($arrTags, array("user_menu","user_menu_tag.php"));
			array_push($arrTags, array("blog_header","blog_header_tag.php"));
			array_push($arrTags, array("blog_categories","blog_categories_tag.php"));
		
			
		}
		array_push($arrTags, array("welcome","welcome_tag.php"));
			
		
		if(is_array($arrTags))
		{
			foreach($arrTags as $arrTag)
			{
				$tag_pos = strpos($this->TemplateHTML,"<site ".$arrTag[0]."/>");
			
				if($tag_pos !== false)
				{
					if(trim($arrTag[1]) != "none" && trim($arrTag[0]) != "" && trim($arrTag[1]) != "")
					{
						$HTML="";
						ob_start();
						include("extensions/".$arrTag[1]);
						
						if($HTML=="")
						{
							$HTML = ob_get_contents();
						}
						ob_end_clean();
								
						$this->TemplateHTML = str_replace("<site ".$arrTag[0]."/>",$HTML,$this->TemplateHTML);
					}
				}
			}
		}

		
		$pattern = "/{(\w+)}/i";
		preg_match_all($pattern, $this->TemplateHTML, $items_found);
		
		
		foreach($items_found[1] as $item_found)
		{
			if(strstr($item_found,"DB")) continue;
			if(isset($$item_found))
			{
				$this->TemplateHTML=str_replace("{".$item_found."}",$$item_found,$this->TemplateHTML);
			}
		}
		
		
	}
	
	
	function format_str($strTitle)
	{
		$strSEPage = ""; 
		$strTitle=strip_tags(stripslashes(strtolower(trim($strTitle))));
		$arrSigns = array("~", "!","\t", "@","1","2","3","4","5","6","7","8","9","0", "#", "$", "%", "^", "&", "*", "(", ")", "+", "-", ",",".","/", "?", ":","<",">","[","]","{","}","|"); 
		
		$strTitle = str_replace($arrSigns, "", $strTitle); 
		
		$pattern = '/[^\w ]+/';
		$replacement = '';
		$strTitle = preg_replace($pattern, $replacement, $strTitle);

		$arrWords = explode(" ",$strTitle);
		$iWCounter = 1; 
		
		foreach($arrWords as $strWord) 
		{ 
			if($strWord == "") { continue; }  
			
			if($iWCounter == 7) { break; }  
			if($iWCounter != 1) { $strSEPage .= "-"; }
			$strSEPage .= $strWord;  
			
			$iWCounter++; 
		} 
		
		return $strSEPage;
		
	}
	
	function page_link($page_name,$page_id,$lang)
	{
		$SEO_URLS=true;
		$MULTI_LANGUAGE=true;
		
		if($SEO_URLS)
		{
			return format_str($page_name)."-".$page_id.($MULTI_LANGUAGE?"-".strtolower($lang):"").".html";
		}
		else
		{
			return "index.php?page=".$page_id.($MULTI_LANGUAGE?"&lang=".strtolower($lang):"");
		
		}
	}
	
	function text_words($string, $wordsreturned)
	{
		$string=trim(stripslashes($string));
		$string=str_replace("\n","",$string);
		$string=str_replace("\t"," ",$string);
		
		$string=str_replace("\r","",$string);
		$string=str_replace("  "," ",$string);
		 $retval = $string;    
		$array = explode(" ", $string);
	  
		if (count($array)<=$wordsreturned)
		{
			$retval = $string;
		}
		else
		{
			array_splice($array, $wordsreturned);
			$retval = implode(" ", $array)." ...";
		}
		return $retval;
	}
	
	function format_keywords($keywords_text)
	{
		$keywords_text = str_replace("-"," ",$keywords_text);
		$keywords_text = strtolower(str_replace(" ",",",str_replace(", ...","",$this->text_words(stripslashes(strip_tags($keywords_text)),30))));
		$keywords_text = str_replace(",,",",",$keywords_text);
		return $keywords_text;
	}
	
	function Title($website_title)
	{
		$this->TemplateHTML = 
		str_replace
		(
			"<site title/>",
			strip_tags(stripslashes($website_title)),
			$this->TemplateHTML
		);
	}
	
	function NoIndex()
	{
		$this->TemplateHTML = 
		str_replace
		(
			"</title>",
			"</title>\n<meta name=\"robots\" content=\"noindex, follow\">",
			$this->TemplateHTML
		);
	}
	
	function MetaDescription($meta_description)
	{
		$this->TemplateHTML = 
		str_replace
		(
			"<site description/>",
			strip_tags(stripslashes($meta_description)),
			$this->TemplateHTML
		);
	}
	
	function MetaKeywords($meta_keywords)
	{
		$this->TemplateHTML = 
		str_replace
		(
			"<site keywords/>",
			strip_tags(stripslashes($meta_keywords)),
			$this->TemplateHTML
		);
	}
	
	function GetParam($param_name)
	{
		switch($param_name)
		{
			
			case "FACEBOOK_PAGE_URL":
				return $this->params[94];
				break;
				
			case "TWITTER_PAGE_URL":
				return $this->params[95];
				break;
				
			case "INSTAGRAM_PAGE_URL":
				return $this->params[96];
				break;
				
		
			case "ENABLE_FACEBOOK_LOGIN":
				return $this->params[138];
				break;
				
			case "FACEBOOK_KEY":
				return $this->params[139];
				break;
			
			case "FACEBOOK_SECRET":
				return $this->params[140];
			break;
				
			case "ENABLE_TWITTER_LOGIN":
				return $this->params[141];
				break;
				
			case "TWITTER_KEY":
				return $this->params[142];
				break;
			
			case "TWITTER_SECRET":
				return $this->params[143];
			break;
				
			case "MAXIMUM_NUMBER_IMAGES":
				return $this->params[98];
				break;
			
			case "SEO_URLS":
				return $this->params[99];
				break;
				
			case "AUTO_APPROVE":
				return $this->params[101];
				break;
				
			case "SYSTEM_EMAIL_ADDRESS":
				return $this->params[102];
				break;
				
			case "SYSTEM_EMAIL_FROM":
				return $this->params[103];
				break;
				
			case "SEND_WELCOME_EMAIL":
				return $this->params[104];
				break;
			
			case "WELCOME_EMAIL_SUBJECT":
				return $this->params[105];
				break;
				
			case "WELCOME_EMAIL_TEXT":
				return $this->params[106];
				break;
			
			case "RESULTS_PER_PAGE":
				return $this->params[107];
				break;
				
			case "NUMBER_OF_CATEGORIES_PER_ROW":
				return $this->params[108];
				break;
				
			case "NUMBER_OF_FEATURED_LISTINGS":
				return $this->params[109];
				break;
			
			case "DEC_POINT":
				return $this->params[110];
				break;
				
			case "THOUSANDS_SEP":
				return $this->params[111];
				break;
				
			case "WEBSITE_CURRENCY":
				return $this->params[112];
				break;
				
			case "CURRENCY":
				return $this->params[112];
				break;
				
			case "CURRENCY_CODE":
				return $this->params[113];
				break;
				
			case "USE_CAPTCHA_IMAGES":
				return $this->params[114];
				break;
				
			case "TIMEZONE":
				return $this->params[115];
				break;
				
			case "PAYPAL_ID":
				return $this->params[116];
				break;

			case "2CHECKOUT_ID":
				return $this->params[117];
				break;	
				
			case "CHEQUES_ADDRESS":
				return $this->params[118];
				break;
				
			case "BANK_ACCOUNT":
				return $this->params[119];
				break;
				
			case "AMAZON_ID":
				return $this->params[120];
				break;
				
			case "AMAZON_ACCESS_KEY":
				return $this->params[121];
				break;
				
			case "AMAZON_SECRET_KEY":
				return $this->params[122];
				break;
				
			case "PAYFAST_ID":
				return $this->params[123];
				break;
				
			case "INTERKASSA_ID":
				return $this->params[124];
				break;
				
			case "GOOGLE_CHECKOUT_ID":
				return $this->params[125];
				break;
				
			case "GOOGLE_CHECKOUT_KEY":
				return $this->params[126];
				break;
				
			case "MONEYBOOKERS_ID":
				return $this->params[127];
				break;
				
			case "PAYMATE_ID":
				return $this->params[128];
				break;
				
			case "SEO_APPEND_TITLE":
				return $this->params[129];
				break;
				
			case "SEO_APPEND_DESCRIPTION":
				return $this->params[130];
				break;
				
			case "SEO_APPEND_KEYWORDS":
				return $this->params[131];
				break;
				
			case "DATE_FORMAT":
				return $this->params[132];
				break;
				
			case "SHOW_LISTINGS_NUMBER":
				return $this->params[133];
				break;
				
			case "VERIFY_EMAIL":
				return $this->params[134];
				break;
				
			case "VERIFY_EMAIL_SUBJECT":
				return $this->params[135];
				break;
				
			case "VERIFY_EMAIL_MESSAGE":
				return $this->params[136];
				break;
			
			case "ENABLE_EMAIL_ALERTS":
				return $this->params[137];
				break;
				
			case "ENABLE_FB_LOGIN":
				return $this->params[138];
				break;
				
			case "FB_APP_ID":
				return $this->params[139];
				break;
				
			case "FB_APP_SECRET":
				return $this->params[140];
				break;
					
				
			
				case "MAX_FILE_SIZE":
				return 20000000;
				break;
				
				
			case "ACCEPTED_FILE_TYPES":
				$file_types = Array 
				(
						array("application/msword","doc"),
						array("application/pdf","pdf"),
						array("text/plain","txt"),
						array("text/rtf","rtf"),
						array("application/rtf","rtf"),
						array("application/octet-stream","docx"),
						array("application/vnd.openxmlformats-officedocument.wordprocessingml.document","docx"),
						array("application/vnd.oasis.opendocument.text","odt")
				);
				return $file_types;
				break;
				
			case "CART_TEMPLATE":
				return $this->params[800];
				break;
				
				
			case "USE_GD":
				return true;
				break;
				
			case "DEFAULT_THUMBNAIL_WIDTH":
				return "100";
				break;
				
			case "LIMIT_THUMBNAIL_HEIGHT":
				return "100";
				break;
				
			case "HOME_PAGE_PRODUCTS_SELECTED_ADMIN":
				return false;
				break;
				
			case "ENABLE_STOCK_MANAGEMENT":
				return false;
				break;
				
			case "USE_ABSOLUTE_URLS":
				return false;
				break;
				
			
				
			case "ENABLE_EMAIL_NOTIFICATIONS":
				return false;
				break;
				
			case "FREE_WEBSITE":
				return false;
				break;
				
			case "CHEQUE_INFO":
				return "cheque payment info";
				break;
				
			case "BANK_INFO":
				return "cheque payment info";
				break;
				
			case "STORES_URL_FORMAT":
				return $this->params[97];
				break;
				
				
			case "LATEST_OR_FEATURED":
				return 1;
				break;
				
			case "HOME_CAROUSEL_POSTS":
				return 3;
				break;
				
			case "SLIDER_CONTENT":
				return $this->params[170];
				break;
				
			case "SLIDER_TYPE":
				return $this->params[171];
				break;
				
				
			case "NEW_USERS_EMAIL_VALIDATION_ON_SIGNUP":
				return ($this->params[431]=="YES"?true:false);
				break;
				
			case "ACTIVATION_TITLE":
				return "";
				break;
				
			case "ACTIVATION_TEXT":
				return "";
				break;
			
		}
	}
	
	
	
	
	function show_full_location($location) 
	{ 
   
	  $str_result=""; 
	   
		if(file_exists("locations/locations_array.php"))
	   {
			include("locations/locations_array.php"); 
	   }
	   else
	   {
			include("../locations/locations_array.php"); 
		}
	
	  $location=str_replace("~",".",$location); 
	  $arr_digits= explode(".",$location); 
	   
	  while(sizeof($arr_digits) >= 1) 
	  { 
	   
	   if(sizeof($arr_digits)==1) 
	   { 
		if(isset($l[$arr_digits[0]])) $str_result = $l[$arr_digits[0]].$str_result; 
	   } 
	   elseif(sizeof($arr_digits)==2) 
	   { 
		if(isset($l1[$arr_digits[0]][$arr_digits[1]] )) $str_result = ", ".$l1[$arr_digits[0]][$arr_digits[1]].$str_result; 
	   } 
	   elseif(sizeof($arr_digits)==3) 
	   { 
		if(isset($l2[$arr_digits[0]][$arr_digits[1]][$arr_digits[2]]))  $str_result = ", ". $l2[$arr_digits[0]][$arr_digits[1]][$arr_digits[2]].$str_result; 
	   } 
	   elseif(sizeof($arr_digits)==4) 
	   { 
		if(isset($l3[$arr_digits[0]][$arr_digits[1]][$arr_digits[2]][$arr_digits[3]]))  $str_result = ", ". $l3[$arr_digits[0]][$arr_digits[1]][$arr_digits[2]][$arr_digits[3]].$str_result; 
	   } 
		
	   array_pop($arr_digits); 
	   
	  } 
	   
	  $str_result_items = explode(",",$str_result); 
	   
	  $str_result_items = array_reverse($str_result_items); 
	  return implode(", ",$str_result_items); 
	   
	} 



	function show_location($location)
	{
		global $l,$l1,$l2,$l3,$l4;
		
		if(!isset($l))
		{
			if(file_exists("locations/locations_array.php")) include_once("locations/locations_array.php");
			elseif(file_exists("../locations/locations_array.php")) include_once("../locations/locations_array.php");
			else return "";
		}

		$arr_digits= explode(".",$location);
		
		if(sizeof($arr_digits)==1)
		{
			if(isset($l[$arr_digits[0]])) return $l[$arr_digits[0]];else return "";
		}
		elseif(sizeof($arr_digits)==2)
		{
			if(isset($l1[$arr_digits[0]][$arr_digits[1]] )) return $l1[$arr_digits[0]][$arr_digits[1]];else return "";
		}
		elseif(sizeof($arr_digits)==3)
		{
			if(isset($l2[$arr_digits[0]][$arr_digits[1]][$arr_digits[2]])) return $l2[$arr_digits[0]][$arr_digits[1]][$arr_digits[2]];else return "";
		}
		elseif(sizeof($arr_digits)==4)
		{
			if(isset($l3[$arr_digits[0]][$arr_digits[1]][$arr_digits[2]][$arr_digits[3]])) return $l3[$arr_digits[0]][$arr_digits[1]][$arr_digits[2]][$arr_digits[3]];else return "";
		}
		else
		{
			return "";
		}
	}
	
	
	
	function show_pic($pic_id,$display_mode="small",$alt_text="",$img_class="", $path = "")
	{
		$pic_id = preg_replace('/^0,/', '', $pic_id);
		$result="";
		if($display_mode=="small"||$display_mode=="small-x")
		{
			$images=explode(",",$pic_id);
			if($pic_id==""||!file_exists($path.'thumbnails/'.$images[0].'.jpg'))
			{
				$result = '<img src="'.($path!=""?$path:$this->get_file_prefix()).'images/no_pic.gif" width="'.($display_mode=="small-x"?"150":"100").'" '.($img_class!=""?'class="'.$img_class.' img-fluid"':'class="img-fluid"').' alt="no picture available"/>';
		
			}
			else
			{
				$result = '<img src="'.($path!=""?$path:$this->get_file_prefix()).'thumbnails/'.$images[0].'.jpg" class="thumb-image" width="'.($display_mode=="small-x"?"150":"150").'" alt="'.$alt_text.'" '.($img_class!=""?'class="'.$img_class.' img-fluid"':'class="img-fluid"').'/>';
			}
		}
		else
		{
			if($pic_id=="")
			{
				$result = '<img src="'.($path!=""?$path:$this->get_file_prefix()).'images/no_pic.gif" width="300" height="250" '.($img_class!=""?'class="'.$img_class.'"':'').' alt="no picture available"/>';
		
			}
			else
			{
				$images=explode(",",$pic_id);
				if(file_exists($path.'uploaded_images/'.$images[0].'.jpg'))
				{
					$result = '<img src="'.($path!=""?$path:$this->get_file_prefix()).'uploaded_images/'.$images[0].'.jpg" width="300" '.($img_class!=""?'class="'.$img_class.' img-fluid"':'class="img-fluid"').' alt="'.$alt_text.'"/>';
				}
		
			}
		}
		
		return $result;
	}
	
	function show_category($category)
	{
		global $l,$l1,$l2,$l3,$l4;
		
		if(!isset($l))
		{
			if(file_exists("categories/categories_array_".$this->lang.".php")) include_once("categories/categories_array_".$this->lang.".php");
			elseif(file_exists("../categories/categories_array_".$this->lang.".php")) include_once("../categories/categories_array_".$this->lang.".php");
			else return "";
		}

		$arr_digits= explode(".",$category);
		
		if(sizeof($arr_digits)==1)
		{
			if(isset($l[$arr_digits[0]])) return $l[$arr_digits[0]];else return "";
		}
		elseif(sizeof($arr_digits)==2)
		{
			if(isset($l1[$arr_digits[0]][$arr_digits[1]] )) return $l1[$arr_digits[0]][$arr_digits[1]];else return "";
		}
		elseif(sizeof($arr_digits)==3)
		{
			if(isset($l2[$arr_digits[0]][$arr_digits[1]][$arr_digits[2]])) return $l2[$arr_digits[0]][$arr_digits[1]][$arr_digits[2]];else return "";
		}
		elseif(sizeof($arr_digits)==4)
		{
			if(isset($l3[$arr_digits[0]][$arr_digits[1]][$arr_digits[2]][$arr_digits[3]])) return $l3[$arr_digits[0]][$arr_digits[1]][$arr_digits[2]][$arr_digits[3]];else return "";
		}
		else
		{
			return "";
		}
	}
	
	function current_url() 
	{
		$pageURL = 'http://';
		
		$pageURL .= $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
		
		return $pageURL;
	}
	
	
	function create_cat_link($key,$arr_categories,$add_html=true)
	{
		
		$key_items=explode(".",$key);
		
		$result="";
		
	
		for($i=sizeof($key_items)-1;$i>=0;$i--)
		{
			$c_items =  array_slice($key_items, 0, sizeof($key_items)-$i);
				
			$c_key = implode(".",$c_items);
			
			if($result!="") $result.="/";
			
			$str_cat_name=strtolower(trim($arr_categories[$c_key]));
			$arrSigns = array("~", "!", "@","#", "$", "%", "^", "&", "*", "(", ")", "+", "-", ",",".","/", "?", ":","<",">","[","]","{","}","|"); 
		
			$str_cat_name = str_replace($arrSigns, "", $str_cat_name); 
			$str_cat_name = str_replace("\t"," ",$str_cat_name);
			$str_cat_name = str_replace("  "," ",$str_cat_name);
			$str_cat_name = str_replace(" ","-",$str_cat_name);
			
			$result.=$str_cat_name;
			
		}
		
		if($add_html)
		{
			$result.="/";
		}
		
		return $result;
	}
	
	
	
	function find_cat_id($category,$arr_categories)
	{
		foreach($arr_categories as $key=>$value)
		{
			$str_c_link = $this->create_cat_link($key,$arr_categories,false);
			
			if(trim($category)==trim($str_c_link))
			{
				return $key;
			}
			
		}
		return 0;
	}
	
	
	function show_stars($vote,$class="")
	{
	
		//$result = "<div ".($class!=""?"class=\"".$class."\"":"").">";
	
	$result="";
		for($x=0;$x<floor($vote);$x++)
		{
			$result .= "<img src=\"".$this->get_file_prefix()."images/full-star.gif\" width=\"13\" height=\"12\" alt=\"\"/>";
		}
		
		for($c=0;$c<ceil(fmod($vote, 1) );$c++)
		{
			$result .= "<img src=\"".$this->get_file_prefix()."images/half-star.gif\" width=\"13\" height=\"12\" alt=\"\"/>";
		}
		
		for($v=($c+$x);$v<5;$v++)
		{
			$result .= "<img src=\"".$this->get_file_prefix()."images/empty-star.gif\" width=\"13\" height=\"12\" alt=\"\"/>";
		}

		//$result .= "</div>";
		
		return $result;
	}
	
	
	function sanitize($input)
	{
		$strip_chars = array("~", "`", "!","#", "$", "%", "^", "&", "*", "(", ")", "=", "+", "[", "{", "]",
                 "}", "\\", "|", ";", ":", "\"", "'", "&#8216;", "&#8217;", "&#8220;", "&#8221;", "&#8211;", "&#8212;",
                 ",", "<", ">", "/", "?");
		$output = trim(str_replace($strip_chars, " ", strip_tags($input)));
		$output = preg_replace('/\s+/', ' ',$output);
		$output = preg_replace('/\-+/', '-',$output);
		return $output;
	}
	
	
	

	
	
	function UpdateListingRating($id)
	{
		global $database,$DBprefix;
		$this->ms_i($id);
		$database->Query("
		UPDATE ".$DBprefix."posts
		SET rate=(
		 SELECT AVG(vote)
		 FROM ".$DBprefix."comments
		 WHERE post_id=".$id."
		),number_comments=(
		 SELECT COUNT(id)
		 FROM ".$DBprefix."comments
		 WHERE post_id=".$id."
		)
		WHERE id=".$id);
		
		
	}
	
	function UpdateUserRating($id)
	{
		global $database,$DBprefix;
		$this->ms_i($id);
		$database->Query("
		UPDATE ".$DBprefix."users
		SET rating=(
		 SELECT AVG(vote)
		 FROM ".$DBprefix."user_reviews
		 WHERE user_id=".$id."
		),number_reviews=(
		 SELECT COUNT(id)
		 FROM ".$DBprefix."user_reviews
		 WHERE user_id=".$id."
		)
		WHERE id=".$id);
	}
	
	
	
	function GetFileType($file_type)
	{ 
	  
		foreach($this->GetParam("ACCEPTED_FILE_TYPES") as $c_file_type) 
		{  
			if($c_file_type[0] == $file_type) 
			return $c_file_type[1];   
		} 
		return "";
	}
	
	
	function format_url($path)
	{
		global $DOMAIN_NAME,$MULTI_LANGUAGE_SITE;
		
		
		if($this->GetParam("SEO_URLS")==0)
		{
			if($MULTI_LANGUAGE_SITE)
			{
				$path .= "&lang=".$this->lang;
			}
			
			if($this->user!="")
			{
				$path .= "&p=".$this->user;
			}
			
			return $path;
		}
		else
		{
			$path=str_replace("index.php?","",$path);
			$path=str_replace("=","-",$path);
			
			if($MULTI_LANGUAGE_SITE)
			{
				$path = $this->lang."-".$path;
			}
			
			if($this->user!="")
			{
				if($this->GetParam("STORES_URL_FORMAT")==1)
				{
					$path = "http".$this->check_https()."://".$this->domain."/".$this->user."/".$path;
				}
				else
				{
					$path = "http".$this->check_https()."://".$this->user.".".str_replace("www.","",$this->domain)."/".$path;
				}
			}
			
			return $path.".html";
		
		}
	
	}
	
	function user_site_link($store_name,$path="")
	{
		$result="";
		if($this->GetParam("SEO_URLS")==0)
		{
			$result="index.php";
			if($this->multi_language)
			{
				$result .= "?lang=".$this->lang;
			}
			
			$result .= (!$this->multi_language?"?":"&")."p=".$store_name;
			
			
			return $path.$result;
		}
		else
		{
			
			if($this->GetParam("STORES_URL_FORMAT")==1)
			{
				$result = "http".$this->check_https()."://".$this->domain."/".$store_name;
			}
			else
			{
				$result = "http".$this->check_https()."://".$store_name.".".str_replace("www.","",$this->domain);
			}
			
		}
		return $result;
	}
	
	
	
	function news_link($news_id,$news_title,$username="")
	{
		global $M_SEO_NEWS;
		
		$result = "";
		
		if($this->GetParam("SEO_URLS")==1)
		{
			$result =$this->get_url_prefix($username).$M_SEO_NEWS."-".$this->format_str($news_title)."-".$news_id.".html";
		}
		else
		{
			
			$url_prefix=$this->get_url_prefix($username);
			if(strpos($url_prefix,"?")!==false) $url_prefix.="&";else $url_prefix.="?";
			
			$result = $url_prefix."mod=news&id=".$news_id;
			
		}
	
		return $result;
	}
	
	function post_link($post_id,$post_title,$username="")
	{
		global $M_SEO_POST;
		
		$result = "";
		
		if($this->GetParam("SEO_URLS")==1)
		{
			$result =$this->get_url_prefix($username).$M_SEO_POST."-".$this->format_str($post_title)."-".$post_id.".html";
		}
		else
		{
			$url_prefix=$this->get_url_prefix($username);
			if(strpos($url_prefix,"?")!==false) $url_prefix.="&";else $url_prefix.="?";
			
			$result = $url_prefix."mod=blog_posts&id=".$post_id;
		}
	
		return $result;
	}
	
	
	
	function album_link($album_id,$album_title)
	{
		global $M_SEO_ALBUM;
		
		$result = "";
		
		if($this->GetParam("SEO_URLS")==1)
		{
			$result =$this->get_url_prefix().$M_SEO_ALBUM."-".$this->format_str($album_title)."-".$album_id.".html";
		}
		else
		{
			$url_prefix=$this->get_url_prefix();
			if(strpos($url_prefix,"?")!==false) $url_prefix.="&";else $url_prefix.="?";
			
			$result = $url_prefix."mod=album&id=".$album_id;
		}
	
		return $result;
	}
	
	
	
	
	function post_review_link($product_id,$product_name)
	{
		global $M_SEO_REVIEW;
		
		$result = "";
		
		if($this->GetParam("SEO_URLS")==1)
		{
			$result =$this->get_url_prefix().$M_SEO_REVIEW."-".$this->format_str($product_name)."-".$product_id.".html";
		}
		else
		{
			$result = $this->get_url_prefix()."&mod=write_comment&id=".$product_id;
		}
	
		return $result;
	}
	
	
	function category_link($category_id,$category_name)
	{
		global $MULTI_LANGUAGE_SITE,$M_SEO_CATEGORY;
		
		$result = "";
		$category_id=str_replace(".","-",$category_id);
		if($this->GetParam("SEO_URLS")==1)
		{
			$result =$this->get_url_prefix().$M_SEO_CATEGORY."-".$this->format_str($category_name)."-".$category_id.".html";
		}
		else
		{
			$url_prefix=$this->get_url_prefix();
			if(strpos($url_prefix,"?")!==false) $url_prefix.="&";else $url_prefix.="?";
			$result = $url_prefix."mod=blogs&category=".$category_id;
		}
	
		return $result;
	}
	
	function blog_category_link($category_id,$category_name)
	{
		global $MULTI_LANGUAGE_SITE,$M_SEO_CATEGORY;
		
		$result = "";
		$category_id=str_replace(".","-",$category_id);
		if($this->GetParam("SEO_URLS")==1)
		{
			$result =$this->get_url_prefix().$M_SEO_CATEGORY."-".$this->format_str($category_name)."-".$category_id.".html";
		}
		else
		{
			$result = $this->get_url_prefix()."&mod=blog_posts&category=".$category_id;
		}
	
		return $result;
	}
	
	
	function user_link($user_id,$user_name)
	{
		global $M_SEO_VENDOR;
		
		$result = "";
		if($this->GetParam("SEO_URLS")==1)
		{
			$result =$this->get_url_prefix().$M_SEO_VENDOR."-".$this->format_str($user_name)."-".$user_id.".html";
		}
		else
		{
			$url_prefix=$this->get_url_prefix();
			if(strpos($url_prefix,"?")!==false) $url_prefix.="&";else $url_prefix.="?";
			$result = $url_prefix."mod=user&id=".$user_id;
		}
	
		return $result;
	}
	
	function user_reviews_link($user_id,$user_name)
	{
		global $M_SEO_REVIEWS;
		
		$result = "";
		if($this->GetParam("SEO_URLS")==1)
		{
			$result =$this->get_url_prefix().$M_SEO_REVIEWS."-".$this->format_str($user_name)."-".$user_id.".html";
		}
		else
		{
			$result = $this->get_url_prefix()."&mod=reviews&id=".$user_id;
		}
	
		return $result;
	}
	
	function user_contact_link($user_name)
	{
		global $M_SEO_CONTACT;
		
		$result = "";
		if($this->GetParam("SEO_URLS")==1)
		{
			$result =$this->get_url_prefix().$M_SEO_CONTACT.".html";
		}
		else
		{
			$result = $this->get_url_prefix()."&mod=contact";
		}
	
		return $result;
	}
	
	function get_file_prefix()
	{
		
		$result = "";
		
		if
		(
			$this->GetParam("SEO_URLS")==1
			&&
			$this->user!=""
		)
		{
			$result ="http".$this->check_https()."://".$this->domain."/";
		}
		
		return $result;
		
	}
	
	function get_url_prefix($username="")
	{
		global $DOMAIN_NAME,$MULTI_LANGUAGE_SITE;
		
		if($this->user!="")
		{
			$username=$this->user;
		}
		
		if($this->GetParam("SEO_URLS")==0)
		{
			$path="index.php";
			if($MULTI_LANGUAGE_SITE)
			{
				$path .= "?lang=".$this->lang;
			}
			
			if($username!="")
			{
				$path .= (!$MULTI_LANGUAGE_SITE?"?":"&")."p=".$username;
			}
			
			return $path;
		}
		else
		{
			$path="";			
			if($username!="")
			{
				if($this->GetParam("STORES_URL_FORMAT")==1)
				{
					$path = "http".$this->check_https()."://".$this->domain."/".$username."/";
				}
				else
				{
					$path = "http".$this->check_https()."://".$username.".".str_replace("www.","",$this->domain)."/";
				}
			}
			
			return $path;
		
		}
	
	}
	
	
	function mod_link($mod)
	{
		global $DOMAIN_NAME,$MULTI_LANGUAGE_SITE;
		
		if($this->GetParam("SEO_URLS")==0)
		{
			return "index.php?mod=".$mod.($MULTI_LANGUAGE_SITE?"&lang=".$this->lang:"");
		}
		else
		{
			if($MULTI_LANGUAGE_SITE)
			{
				return "mod-".$this->lang."-".$mod.".html";
			}
			else
			{
				return "mod-".$mod.".html";
			}
		}
	
	}
	
	function time_since($since) 
	{
		$since=time()-$since;
		$chunks = array(
			array(60 * 60 * 24 * 365 , 'year'),
			array(60 * 60 * 24 * 30 , 'month'),
			array(60 * 60 * 24 * 7, 'week'),
			array(60 * 60 * 24 , 'day'),
			array(60 * 60 , 'hour'),
			array(60 , 'minute'),
			array(1 , 'second')
		);

		for ($i = 0, $j = count($chunks); $i < $j; $i++) {
			$seconds = $chunks[$i][0];
			$name = $chunks[$i][1];
			if (($count = floor($since / $seconds)) != 0) {
				break;
			}
		}

		$print = ($count == 1) ? '1 '.$name : "$count {$name}s";
		return $print;
	}
	
	
	function check_https() 
	{
		if
		(
			(!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off')
			|| $_SERVER['SERVER_PORT'] == 443
		)
		{
			return "s";
		}
		else
		{
			return "";
		}
		
		
	}
	
	function external_link($url)
	{
		$pos_http = strpos($url, "http");
		
		return ($pos_http===false?"http://":"").$url;
	}
	
	function get_between_tags($string, $tagname)
	{
		$pattern = "/<!--$tagname([\s\S]+)$tagname-->/";
		preg_match($pattern, $string, $matches);
		if(isset($matches[1]))
		{
			return $matches[1];
		}
		else
		{
			return "";
		}
	}
	
	
	function send_mail($email_address, $email_subject, $email_text, $headers="", $attachments=array())
	{
	
		if($this->GetParam("SEND_EMAILS")==false)
		{
			
		}
		else
		if($this->GetParam("USE_SMTP")==0)
		{
			$headers  = "From: \"".$this->GetParam("SYSTEM_EMAIL_FROM")."\" <".$this->GetParam("SYSTEM_EMAIL_ADDRESS").">\n";
			$headers .= "MIME-Version: 1.0\r\n";
			$headers .= "Date: ".date("r")."\r\n";
			$headers .= "Message-ID: <".time()."@".$this->domain.">\r\n";
			$headers .= "Content-Type: text/html; charset=utf-8\r\n";

			if(mail($email_address, $email_subject, str_replace("\n","\r\n",$email_text), $headers))
			{
				return true;
			}
			else
			{
				return false;
			}
		}
		else
		{
			if(file_exists("include/class.phpmailer.php"))
			{
				include("include/class.phpmailer.php");
			}
			else
			if(file_exists("../include/class.phpmailer.php"))
			{
				include("../include/class.phpmailer.php");
			}
			else
			{
				return false;
			}
			
			$mail = new PHPMailer();
			$mail->IsSMTP();
			$mail->Host=$this->GetParam("SMTP_SERVER");
			$mail->SMTPAuth=true;
			
			if($this->GetParam("SMTP_SECURE")!=""&&$this->GetParam("SMTP_SECURE")!="none")
			{
				$mail->SMTPSecure = $this->GetParam("SMTP_SECURE");
			}
			
			if($this->GetParam("SMTP_PORT")!="")
			{
				$mail->Port=$this->GetParam("SMTP_PORT");
			}
			
			$mail->Username   = $this->GetParam("SMTP_USER");
			$mail->Password   = $this->GetParam("SMTP_PASSWORD");      
			
			$mail->isHTML(true);
			$mail->CharSet = 'UTF-8';
			
			$mail->SetFrom( $this->GetParam("SMTP_USER"), $this->GetParam("SYSTEM_EMAIL_FROM"));
		
					
			$mail->Subject = $email_subject;
			
			$mail->MsgHTML(nl2br($email_text));
			
			$mail->AddAddress($email_address, $email_address);

			if(sizeof($attachments) > 0)
			{
			
				for($f=0;$f<sizeof($attachments);$f++)
				{
					$mail->addAttachment($attachments[$f]);
				}
			}
			
			if($mail->Send())
			{
				return true;
			}
			else
			{
				return false;
			}

		}	
		
		
	}
	
	
}	
?>